interface gameData {

  globals: {
    gameWidth: number,
    gameHeight: number,
    bgColor: string,
    debug: boolean
  },

  preloader: {
    bgColor: string,
    image: string,
    imageX: number,
    imageY: number,
    loadingText: string,
    loadingTextFont: string,
    loadingTextComplete: string,
    loadingTextY: number
    loadingBarColor: number,
    loadingBarY: number
  },

  spritesheets?: Array<SpritesheetsAsset>,
  images?: Array<ImageAsset>,
  atlas?: Array<AtlasAsset>,
  sounds?: Array<SoundAsset>,
  videos?: Array<VideoAsset>,
  audios?: Array<AudioSpriteAsset>,
  bitmapfonts?: Array<BitmapfontAsset>,
  scripts?: Array<ScriptAsset>,
  tilemaps?: Array<TileMapsAsset>,
  fonts?: Array<FontAsset>,

}

interface genericConfig {
  scene: Phaser.Scene;
  x: number;
  y: number;
  key: string;
}
interface playerConfig extends genericConfig{
  life:number;
  jump:number;
}

interface ImageAsset {
  name: string;
  path: string;
}

interface VideoAsset {
  name: string;
  path: string;
}

interface ScriptAsset {
  key: string;
  path: string;
}

interface TileMapsAsset {
  key: string;
  path: string;
}

interface FontAsset {
  key: string;
}

interface SpritesheetsAsset {
  name: string;
  path: string;
  width: number;
  height: number;
  frames?: number;
  spacing?: number;
  margin?:number;
}

interface SoundAsset {
  name: string;
  paths: Array<string>;
}

interface AudioSpriteAsset {
  name: string;
  jsonpath: string;
  paths: Array<string>;
}

interface BitmapfontAsset {
  name: string;
  imgpath: string;
  xmlpath: string;
}

interface AtlasAsset {
  key: string;
  imagepath: string;
  jsonpath: string;
}

interface playerData{
  life:number; 
  jump:number;
}

interface audioData{
  value:boolean;
}



